------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
private with Ada.Finalization;
with Qt4.Fonts;
with Qt4.Strings;
private with Qt_Ada.Internals.Value_Class_Sizes;
with System;

package Qt4.Font_Infos is

   type Q_Font_Info (<>) is tagged private;

   function Create
    (Font : Qt4.Fonts.Q_Font'Class)
       return Q_Font_Info;

   function Bold
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Exact_Match
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Family
    (Self : Q_Font_Info'Class)
       return Qt4.Strings.Q_String;

   function Fixed_Pitch
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Italic
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Pixel_Size
    (Self : Q_Font_Info'Class)
       return Qt4.Q_Integer;

   function Point_Size
    (Self : Q_Font_Info'Class)
       return Qt4.Q_Integer;

   function Point_Size_F
    (Self : Q_Font_Info'Class)
       return Qt4.Q_Real;

   function Raw_Mode
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Style
    (Self : Q_Font_Info'Class)
       return Qt4.Fonts.Font_Style;

   function Style_Hint
    (Self : Q_Font_Info'Class)
       return Qt4.Fonts.Font_Style_Hint;

   function Weight
    (Self : Q_Font_Info'Class)
       return Qt4.Q_Integer;

   function Overline
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Strike_Out
    (Self : Q_Font_Info'Class)
       return Boolean;

   function Underline
    (Self : Q_Font_Info'Class)
       return Boolean;

   package Internals is

      type QFontInfo is private;

      type QFontInfo_Access is access all QFontInfo;
      pragma Convention (C, QFontInfo_Access);

      function QFontInfo_View
       (Item : Q_Font_Info'Class)
          return QFontInfo_Access;
      pragma Inline (QFontInfo_View);

      function To_Pointer
       (Address : System.Address)
          return QFontInfo_Access;
      pragma Inline (To_Pointer);

      function To_Address
       (Pointer : QFontInfo_Access)
          return System.Address;
      pragma Inline (To_Address);

      function Create_Wrapper
       (Item : Internals.QFontInfo_Access)
          return Q_Font_Info;

      function Create_Uninitialized return Q_Font_Info;

      function Storage
       (Item : Q_Font_Info'Class)
          return System.Address;
      pragma Inline (Storage);

      procedure Set_QFontInfo_View
       (Item : in out Q_Font_Info'Class;
        View : QFontInfo_Access);
      pragma Inline (Set_QFontInfo_View);

   private

      type QFontInfo is record
         Placeholder : Interfaces.C.char_array (1 .. Qt_Ada.Internals.Value_Class_Sizes.QFontInfo_C_Size_Of);
      end record;
      pragma Convention (C, QFontInfo);

   end Internals;

private

   type Q_Font_Info is new Ada.Finalization.Controlled with record
      Storage : aliased Internals.QFontInfo;
      Object  : Internals.QFontInfo_Access := null;
      Wrapper : Boolean := False;
   end record;

   overriding
   procedure Adjust (Self : in out Q_Font_Info);

   overriding
   procedure Finalize (Self : in out Q_Font_Info);

end Qt4.Font_Infos;
